package fillCages;

import java.util.ArrayList;

public class Cage {
	static ArrayList<double[]> CARBON_CH4 = new ArrayList<>();
	static ArrayList<double[]> HYDROGEN_CH4 = new ArrayList<>();
	static ArrayList<double[]> CARBON_CHX = new ArrayList<>();
	static ArrayList<double[]> HYDROGEN_CHX = new ArrayList<>();
	static ArrayList<double[]> CARBON_BNZ = new ArrayList<>();
	static ArrayList<double[]> HYDROGEN_BNZ = new ArrayList<>();
	static String[] CARBON_NAMES_CH4;
	static String[] CARBON_NAMES_CHX;
	static String[] CARBON_NAMES_BNZ;
	static String[] HYDROGEN_NAMES_CH4;
	static String[] HYDROGEN_NAMES_CHX;
	static String[] HYDROGEN_NAMES_BNZ;
	ArrayList<double[]> carbon = new ArrayList<>();
	ArrayList<double[]> hydrogen = new ArrayList<>();
	String[] carbon_names;
	String[] hydrogen_names;
	static int startIndex = 737;
	static int startResid = 47;
	double[] center;
	String type;
	
	public static void inputData() {
		CARBON_NAMES_CH4 = new String[] {"C1"};
		CARBON_CH4.add(new double[] {0.000,0.000,0.000});
		HYDROGEN_NAMES_CH4 = new String[] {"H1","H2","H3","H4"};
		HYDROGEN_CH4.add(new double[] {-1.087,0.231,-0.020});
		HYDROGEN_CH4.add(new double[] {0.234,-0.606,-0.901});
		HYDROGEN_CH4.add(new double[] {0.273,-0.571,0.913});
		HYDROGEN_CH4.add(new double[] {0.579,0.948,-0.031});

		CARBON_NAMES_CHX = new String[] {"C1","C2","C3","C4","C5","C6"};
		CARBON_CHX.add(new double[] {-1.266,-0.695,0.285});
		CARBON_CHX.add(new double[] {-1.245,0.758,-0.214});
		CARBON_CHX.add(new double[] {-0.043,-1.449,-0.257});
		CARBON_CHX.add(new double[] {0.042,1.450,0.257});
		CARBON_CHX.add(new double[] {1.244,-0.756,0.213});
		CARBON_CHX.add(new double[] {1.265,0.696,-0.287});
		HYDROGEN_NAMES_CH4 = new String[] {"H1","H2","H3","H4","H5","H6","H7","H8","H9","H10","H11","H12"};
		HYDROGEN_CHX.add(new double[] {-1.242,-0.704,1.396});
		HYDROGEN_CHX.add(new double[] {-2.194,-1.193,-0.070});
		HYDROGEN_CHX.add(new double[] {-1.285,0.767,-1.324});
		HYDROGEN_CHX.add(new double[] {-2.125,1.300,0.193});
		HYDROGEN_CHX.add(new double[] {-0.058,-2.495,0.119});
		HYDROGEN_CHX.add(new double[] {-0.075,-1.454,-1.368});
		HYDROGEN_CHX.add(new double[] {0.057,2.495,-0.118});
		HYDROGEN_CHX.add(new double[] {0.075,1.453,1.367});
		HYDROGEN_CHX.add(new double[] {1.283,-0.765,1.324});
		HYDROGEN_CHX.add(new double[] {2.125,-1.299,-0.193});
		HYDROGEN_CHX.add(new double[] {1.240,0.704,-1.397});
		HYDROGEN_CHX.add(new double[] {2.193,1.194,0.067});
		
		CARBON_NAMES_BNZ = new String[] {"CD1","CE1","CZ","CE2","CD2","CG"};
		CARBON_BNZ.add(new double[] {-1.180,0.727,0.0428});
		CARBON_BNZ.add(new double[] {0.039,1.385,0.0038});
		CARBON_BNZ.add(new double[] {1.219,0.658,-0.0382});
		CARBON_BNZ.add(new double[] {1.179,-0.727,-0.0422});
		CARBON_BNZ.add(new double[] {-0.040,-1.386,-0.0042});
		CARBON_BNZ.add(new double[] {-1.219,-0.659,0.0388});
		HYDROGEN_NAMES_BNZ = new String[] {"HD1","HE1","HZ","HE2","HD2","HG"};
		HYDROGEN_BNZ.add(new double[] {-2.125,1.309,0.0768});
		HYDROGEN_BNZ.add(new double[] {0.071,2.496,0.0078});
		HYDROGEN_BNZ.add(new double[] {2.196,1.186,-0.0692});
		HYDROGEN_BNZ.add(new double[] {2.124,-1.31,-0.0772});
		HYDROGEN_BNZ.add(new double[] {-0.072,-2.496,-0.0072});
		HYDROGEN_BNZ.add(new double[] {-2.196,-1.187,0.0688});
		
	}
	
	public Cage(double[] center, String type) {
		this.center = center;
		this.type = type;
		insertMolecule();
	}
	
	private void insertMolecule() {
		if ( type.equals("METH") ) {
			for (double[] coord  : CARBON_CH4) {
				carbon.add(new double[] {coord[0]+center[0],coord[1]+center[1],coord[2]+center[2]});
			}
			for (double[] coord  : HYDROGEN_CH4) {
				hydrogen.add(new double[] {coord[0]+center[0],coord[1]+center[1],coord[2]+center[2]});
			}
			carbon_names = CARBON_NAMES_CH4;
			hydrogen_names = HYDROGEN_NAMES_CH4;
		} else if ( type.equals("CYCH") ) {
			for (double[] coord  : CARBON_CHX) {
				carbon.add(new double[] {coord[0]+center[0],coord[1]+center[1],coord[2]+center[2]});
			}
			for (double[] coord  : HYDROGEN_CHX) {
				hydrogen.add(new double[] {coord[0]+center[0],coord[1]+center[1],coord[2]+center[2]});
			}
			carbon_names = CARBON_NAMES_CHX;
			hydrogen_names = HYDROGEN_NAMES_CHX;
		} else if ( type.equals("BENZ") ) {
			for (double[] coord  : CARBON_BNZ) {
				carbon.add(new double[] {coord[0]+center[0],coord[1]+center[1],coord[2]+center[2]});
			}
			for (double[] coord  : HYDROGEN_BNZ) {
				hydrogen.add(new double[] {coord[0]+center[0],coord[1]+center[1],coord[2]+center[2]});
			}
			carbon_names = CARBON_NAMES_BNZ;
			hydrogen_names = HYDROGEN_NAMES_BNZ;
		} 
	}
	
	public String toString() {
		StringBuffer output = new StringBuffer();
		StringBuffer current = new StringBuffer();
		String ID, x, y, z;
		int IDSize, xSize, ySize, zSize;
		double[] coord;
		for ( int i = 0 ; i < carbon.size() ; i++ ) {
			current.append("                                       ");
			current.append("                                       ");
			current.insert(0, "ATOM   ");
			ID = String.valueOf(i+startIndex);
			IDSize = ID.length();
			current.replace(11-IDSize, 11, ID);
			current.replace(13, 25, "C   " + type + "    0");
			ID = carbon_names[i];
			IDSize = ID.length();
			current.replace(13, 13+IDSize, ID);
			ID = String.valueOf(startResid);
			IDSize = ID.length();
			current.replace(26-IDSize, 26, ID);
			coord = carbon.get(i);
			x = String.format("%1$.3f", coord[0]);
			y = String.format("%1$.3f", coord[1]);
			z = String.format("%1$.3f", coord[2]);
			xSize = x.length();
			ySize = y.length();
			zSize = z.length();
			current.replace(38-xSize, 38, x);
			current.replace(46-ySize, 46, y);
			current.replace(54-zSize, 54, z);
			current.insert(56, "1.00  0.00      FIL");
			current.append("\n");
			output.append(current);
			current.setLength(0);
		}
		int index = startIndex+carbon.size();
		for ( int i = 0 ; i < hydrogen.size()  ; i++ ) {
			current.append("                                       ");
			current.append("                                       ");
			current.insert(0, "ATOM   ");
			ID = String.valueOf(i+index);
			IDSize = ID.length();
			current.replace(11-IDSize, 11, ID);
			current.replace(13, 25, "H   " + type + "    0");
			ID = hydrogen_names[i];
			IDSize = ID.length();
			current.replace(13, 13+IDSize, ID);
			ID = String.valueOf(startResid);
			IDSize = ID.length();
			current.replace(26-IDSize, 26, ID);
			coord = hydrogen.get(i);
			x = String.format("%1$.3f", coord[0]);
			y = String.format("%1$.3f", coord[1]);
			z = String.format("%1$.3f", coord[2]);
			xSize = x.length();
			ySize = y.length();
			zSize = z.length();
			current.replace(38-xSize, 38, x);
			current.replace(46-ySize, 46, y);
			current.replace(54-zSize, 54, z);
			current.insert(56, "1.00  0.00      FIL");
			current.append("\n");
			output.append(current);
			current.setLength(0);
		}
		startIndex = startIndex + hydrogen.size() + carbon.size();
		startResid++;
		return output.toString();
	}
	
}
