package fillCages;

import java.util.ArrayList;
import java.util.Collections;

public class Driver {
	
	static int structure = 1;
	static int A = 2;
	static int B = 2;
	static int C = 1;
//	static double box = 17.175;     // for structure 2
	static double box = 11.877;     // for structure 1
	static double four= box/4;
	static double eight = four*2;
	static double twelve = four*3;
	static double two = box/8;
	static double six = two*3;
	static double ten = two*5;
	static double fifteen = two*7;
	static double TSM = 1;
	static double TLC = 0;
	static double TLB = 1;
	static double TLM = 0;
	static ArrayList<double[]> small = new ArrayList<>();
	static ArrayList<double[]> large = new ArrayList<>();
	static ArrayList<double[]> smallTotal = new ArrayList<>();
	static ArrayList<double[]> largeTotal = new ArrayList<>();
	static ArrayList<Cage> cages = new ArrayList<>();
	
	public static void main(String[] args) {
		Cage.inputData();
		findCenters();
		fillCages();
		printCages();
	}

	public static void printCages() {
		for (Cage cage : cages) {
			System.out.print(cage.toString());
		}
	}
	
	public static void fillCages() {
		int SM = (int)Math.ceil(smallTotal.size()*TSM);
		for ( int i = 0 ; i < SM ; i++ ) {
			cages.add(new Cage(smallTotal.get(i),"METH"));
		}
		int LM = (int)Math.ceil(largeTotal.size()*TLM);
		for ( int i = 0 ; i < LM ; i++ ) {
			cages.add(new Cage(largeTotal.get(i),"METH"));
		}
		int LC = LM + (int)Math.ceil(largeTotal.size()*TLC);
		for ( int i = LM ; i < LC ; i++ ) {
			cages.add(new Cage(largeTotal.get(i),"CYCH"));
		}
		int LB = LC + (int)Math.ceil(largeTotal.size()*TLB);
		for ( int i = LC ; i < LB ; i++ ) {
			cages.add(new Cage(largeTotal.get(i),"BENZ"));
		}
	}

	public static void findCenters() {
		
		if ( structure == 2 ) {
			
			small.add(new double[] {eight,four,four});
			small.add(new double[] {four,eight,four});
			small.add(new double[] {four,four,eight});
			small.add(new double[] {eight,eight,eight});
			small.add(new double[] {eight,twelve,twelve});
			small.add(new double[] {twelve,eight,twelve});
			small.add(new double[] {twelve,twelve,eight});
			small.add(new double[] {box,twelve,four});
			small.add(new double[] {box,four,twelve});
			small.add(new double[] {four,box,twelve});
			small.add(new double[] {twelve,box,four});
			small.add(new double[] {four,twelve,box});
			small.add(new double[] {twelve,four,box});
			small.add(new double[] {eight,box,box});
			small.add(new double[] {box,eight,box});
			small.add(new double[] {box,box,eight});
			
			large.add(new double[] {two,two,two});
			large.add(new double[] {fifteen,fifteen,fifteen});
			large.add(new double[] {fifteen,six,six});
			large.add(new double[] {six,fifteen,six});
			large.add(new double[] {six,six,fifteen});
			large.add(new double[] {two,ten,ten});
			large.add(new double[] {ten,two,ten});
			large.add(new double[] {ten,ten,two});
		}
		
		if ( structure == 1 ) {	
		
			small.add(new double[] {5.9385000000,0.0000000000,8.9077500000});
			small.add(new double[] {5.9385000000,0.0000000000,2.9692500000});
			small.add(new double[] {0.0000000000,8.9077500000,5.9385000000});
			small.add(new double[] {0.0000000000,2.9692500000,5.9385000000});
			small.add(new double[] {8.9077500000,5.9385000000,0.0000000000});
			small.add(new double[] {5.9385000000,5.9385000000,5.9385000000});
			small.add(new double[] {2.9692500000,5.9385000000,0.0000000000});
			small.add(new double[] {0.0000000000,0.0000000000,0.0000000000});
		
		}
		
		for (int i = 0 ; i < A ; i++) {
			for (int j = 0 ; j < B ; j++) {
				for (int k = 0 ; k < C ; k++) {
					for (double[] coord : small) {
						smallTotal.add(new double[] {coord[0]+box*i,coord[1]+box*j,coord[2]+box*k});
					}
					for (double[] coord : large) {
						largeTotal.add(new double[] {coord[0]+box*i,coord[1]+box*j,coord[2]+box*k});
					}
					
				}
			}
		}
		
		
		// filling half-cages on the right-most side of the hydrate slab
		ArrayList<double[]> addSmall = new ArrayList<>();
		
		for (double[] coord : smallTotal) {
			if ( coord[2] == 0 ) {
				addSmall.add(new double[] {coord[0],coord[1],coord[2]+box*(C)});
			}
		}
		
		for (double[] coord : addSmall) {
			smallTotal.add(coord);
		}
		
		
//		ArrayList<double[]> discardSmall = new ArrayList<>();
//		ArrayList<double[]> discardLarge = new ArrayList<>();
		
//		for (double[] coord : smallTotal) {
//			if ( coord[2] == box*C ) {
//				discardSmall.add(coord);
//			}
//		} 
//		
//		for (double[] coord : largeTotal) {
//			if ( coord[2] == box*C ) {
//				discardLarge.add(coord);
//			}
//		}
//		
//		for (double[] coord : discardSmall) {
//			smallTotal.remove(coord);
//		}
//		
//		for (double[] coord : discardLarge) {
//			largeTotal.remove(coord);
//		}
		
		Collections.shuffle(smallTotal);
		Collections.shuffle(largeTotal);
		
	}

	
	
	
}
