package minimizeDipole;

import java.io.IOException;
import java.util.Collections;

public class Driver {

	final static double BOND_LENGTH = 0.9572; 
	final static double BOND_ANGLE = 104.52; 
	final static double LONE_PAIR_RADIUS = 	0.1250; // tip4p-ew
	final static double OXY_SPACING = 2.9; // structure 2
	final static double MOL_DIPOLE = 2.18;
//	final static double[] CENTER = new double[] {33.787/2 , 33.787/2 , 16.612/2};
	final static double[] CENTER = new double[] {17.175/2 , 17.175/2 , 17.175/2};
//	final static double[] CENTER = new double[] {34.35/2 , 17.175/2 , 17.175/2};
//	final static double[] CENTER = new double[] {34.35/2 , 34.35/2 , 34.35/2};
//	final static double[] CENTER = new double[] {11.877/2 , 11.877/2 , 11.877/2};
	
	public static void main(String[] args) {
		String filePath = "F:\\My Stuff\\Research\\ajr\\crystal\\smallSlab.pdb";
		String outputPath = "F:\\My Stuff\\Research\\ajr\\crystal\\minimizeDipoleSmall.pdb";
		
		try {
			Crystal testCrystal = new Crystal(filePath);
			Collections.sort(testCrystal.oxyList);
			testCrystal.findOxyNeighbors();
			testCrystal.checkNeighborCount();
			testCrystal.minimizeDipole();
			testCrystal.fixAllAngles();
			System.out.println(testCrystal);
			testCrystal.toPDB(outputPath);
		} catch(IOException e) {
			System.out.println("File Not Found");
		}

	}
	

}
